import 'dart:typed_data';
import 'dart:async';

// ignore: camel_case_types
class Xunfei_AudioTranslation_Result_Audio {
  final List<Uint8List> _buffer = [];
  final _streamController = StreamController<Uint8List>();

  // 向音频流添加数据
  void addAudioData(Uint8List data) {
    _buffer.add(data);
    _streamController.add(data); // 每当添加新数据时，推送到流
  }

  // 获取音频数据流
  Stream<Uint8List> get audioStream => _streamController.stream;

  // 获取当前缓存的所有数据
  List<Uint8List> get buffer => List.from(_buffer);

  // 关闭流
  void close() {
    _streamController.close();
  }
}
